package mezz.jei.common.gui;

import mezz.jei.api.ingredients.IIngredientRenderer;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.ingredients.ITypedIngredient;
import mezz.jei.api.runtime.IIngredientManager;
import mezz.jei.common.platform.IPlatformRenderHelper;
import mezz.jei.common.platform.Services;
import net.minecraft.class_1799;
import net.minecraft.class_2561;
import net.minecraft.class_310;
import net.minecraft.class_327;
import net.minecraft.class_437;
import net.minecraft.class_4587;
import net.minecraft.class_5632;
import java.util.List;
import java.util.Optional;

public final class TooltipRenderer {
	private TooltipRenderer() {
	}

	public static void drawHoveringText(class_4587 poseStack, List<class_2561> textLines, int x, int y) {
		class_310 minecraft = class_310.method_1551();
		class_327 font = minecraft.field_1772;
		drawHoveringText(poseStack, textLines, x, y, class_1799.field_8037, font);
	}

	public static <T> void drawHoveringText(class_4587 poseStack, List<class_2561> textLines, int x, int y, ITypedIngredient<T> typedIngredient, IIngredientManager ingredientManager) {
		IIngredientType<T> ingredientType = typedIngredient.getType();
		T ingredient = typedIngredient.getIngredient();
		IIngredientRenderer<T> ingredientRenderer = ingredientManager.getIngredientRenderer(ingredientType);
		drawHoveringText(poseStack, textLines, x, y, ingredient, ingredientRenderer);
	}

	public static <T> void drawHoveringText(class_4587 poseStack, List<class_2561> textLines, int x, int y, T ingredient, IIngredientRenderer<T> ingredientRenderer) {
		class_310 minecraft = class_310.method_1551();
		class_327 font = ingredientRenderer.getFontRenderer(minecraft, ingredient);
		class_1799 itemStack = ingredient instanceof class_1799 ? (class_1799) ingredient : class_1799.field_8037;
		drawHoveringText(poseStack, textLines, x, y, itemStack, font);
	}

	private static void drawHoveringText(class_4587 poseStack, List<class_2561> textLines, int x, int y, class_1799 itemStack, class_327 font) {
		class_310 minecraft = class_310.method_1551();
		class_437 screen = minecraft.field_1755;
		if (screen == null) {
			return;
		}

		Optional<class_5632> tooltipImage = itemStack.method_32347();
		IPlatformRenderHelper renderHelper = Services.PLATFORM.getRenderHelper();
		renderHelper.renderTooltip(screen, poseStack, textLines, tooltipImage, x, y, font, itemStack);
	}
}
