package mezz.jei.common.input.keys;

import mezz.jei.api.runtime.IJeiKeyMapping;
import net.minecraft.class_2561;
import net.minecraft.class_3675;
import java.util.Arrays;
import java.util.List;

public class JeiMultiKeyMapping implements IJeiKeyMapping {
    private final List<IJeiKeyMapping> mappings;

    public JeiMultiKeyMapping(IJeiKeyMapping... mappings) {
        this.mappings = Arrays.asList(mappings);
    }

    @Override
    public boolean isActiveAndMatches(class_3675.class_306 key) {
        return this.mappings.stream()
            .anyMatch(m -> m.isActiveAndMatches(key));
    }

    @Override
    public boolean isUnbound() {
        return this.mappings.stream()
            .allMatch(IJeiKeyMapping::isUnbound);
    }

    @Override
    public class_2561 getTranslatedKeyMessage() {
        return this.mappings.stream()
            .filter(m -> !m.isUnbound())
            .map(IJeiKeyMapping::getTranslatedKeyMessage)
            .findFirst()
            .orElseGet(() ->
                this.mappings.stream()
                .map(IJeiKeyMapping::getTranslatedKeyMessage)
                .findFirst()
                .orElseGet(() -> class_2561.method_43470("error"))
            );
    }
}
